<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfBase64Binary ArrayType
 * @subpackage Arrays
 */
class ArrayOfBase64Binary extends AbstractStructArrayBase
{
    /**
     * The APPRESPONSE
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Base64Binary[]
     */
    public $APPRESPONSE;
    /**
     * Constructor method for ArrayOfBase64Binary
     * @uses ArrayOfBase64Binary::setAPPRESPONSE()
     * @param \StructType\Base64Binary[] $aPPRESPONSE
     */
    public function __construct(array $aPPRESPONSE = array())
    {
        $this
            ->setAPPRESPONSE($aPPRESPONSE);
    }
    /**
     * Get APPRESPONSE value
     * @return \StructType\Base64Binary[]|null
     */
    public function getAPPRESPONSE()
    {
        return $this->APPRESPONSE;
    }
    /**
     * Set APPRESPONSE value
     * @throws \InvalidArgumentException
     * @param \StructType\Base64Binary[] $aPPRESPONSE
     * @return \ArrayType\ArrayOfBase64Binary
     */
    public function setAPPRESPONSE(array $aPPRESPONSE = array())
    {
        foreach ($aPPRESPONSE as $arrayOfBase64BinaryAPPRESPONSEItem) {
            // validation for constraint: itemType
            if (!$arrayOfBase64BinaryAPPRESPONSEItem instanceof \StructType\Base64Binary) {
                throw new \InvalidArgumentException(sprintf('The APPRESPONSE property can only contain items of \StructType\Base64Binary, "%s" given', is_object($arrayOfBase64BinaryAPPRESPONSEItem) ? get_class($arrayOfBase64BinaryAPPRESPONSEItem) : gettype($arrayOfBase64BinaryAPPRESPONSEItem)), __LINE__);
            }
        }
        $this->APPRESPONSE = $aPPRESPONSE;
        return $this;
    }
    /**
     * Add item to APPRESPONSE value
     * @throws \InvalidArgumentException
     * @param \StructType\Base64Binary $item
     * @return \ArrayType\ArrayOfBase64Binary
     */
    public function addToAPPRESPONSE(\StructType\Base64Binary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Base64Binary) {
            throw new \InvalidArgumentException(sprintf('The APPRESPONSE property can only contain items of \StructType\Base64Binary, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->APPRESPONSE[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Base64Binary|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Base64Binary|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Base64Binary|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Base64Binary|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Base64Binary|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string APPRESPONSE
     */
    public function getAttributeName()
    {
        return 'APPRESPONSE';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfBase64Binary
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
