<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfENVELOPE ArrayType
 * @subpackage Arrays
 */
class ArrayOfENVELOPE extends AbstractStructArrayBase
{
    /**
     * The ENVELOPE
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ENVELOPE[]
     */
    public $ENVELOPE;
    /**
     * Constructor method for ArrayOfENVELOPE
     * @uses ArrayOfENVELOPE::setENVELOPE()
     * @param \StructType\ENVELOPE[] $eNVELOPE
     */
    public function __construct(array $eNVELOPE = array())
    {
        $this
            ->setENVELOPE($eNVELOPE);
    }
    /**
     * Get ENVELOPE value
     * @return \StructType\ENVELOPE[]|null
     */
    public function getENVELOPE()
    {
        return $this->ENVELOPE;
    }
    /**
     * Set ENVELOPE value
     * @throws \InvalidArgumentException
     * @param \StructType\ENVELOPE[] $eNVELOPE
     * @return \ArrayType\ArrayOfENVELOPE
     */
    public function setENVELOPE(array $eNVELOPE = array())
    {
        foreach ($eNVELOPE as $arrayOfENVELOPEENVELOPEItem) {
            // validation for constraint: itemType
            if (!$arrayOfENVELOPEENVELOPEItem instanceof \StructType\ENVELOPE) {
                throw new \InvalidArgumentException(sprintf('The ENVELOPE property can only contain items of \StructType\ENVELOPE, "%s" given', is_object($arrayOfENVELOPEENVELOPEItem) ? get_class($arrayOfENVELOPEENVELOPEItem) : gettype($arrayOfENVELOPEENVELOPEItem)), __LINE__);
            }
        }
        $this->ENVELOPE = $eNVELOPE;
        return $this;
    }
    /**
     * Add item to ENVELOPE value
     * @throws \InvalidArgumentException
     * @param \StructType\ENVELOPE $item
     * @return \ArrayType\ArrayOfENVELOPE
     */
    public function addToENVELOPE(\StructType\ENVELOPE $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ENVELOPE) {
            throw new \InvalidArgumentException(sprintf('The ENVELOPE property can only contain items of \StructType\ENVELOPE, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ENVELOPE[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ENVELOPE|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ENVELOPE|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ENVELOPE|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ENVELOPE|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ENVELOPE|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ENVELOPE
     */
    public function getAttributeName()
    {
        return 'ENVELOPE';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfENVELOPE
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
