<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ENVELOPE StructType
 * @subpackage Structs
 */
class ENVELOPE extends AbstractStructBase
{
    /**
     * The INSTANCEIDENTIFIER
     * @var string
     */
    public $INSTANCEIDENTIFIER;
    /**
     * The HEADER
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\HEADER
     */
    public $HEADER;
    /**
     * The CONTENT
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Base64Binary
     */
    public $CONTENT;
    /**
     * Constructor method for ENVELOPE
     * @uses ENVELOPE::setINSTANCEIDENTIFIER()
     * @uses ENVELOPE::setHEADER()
     * @uses ENVELOPE::setCONTENT()
     * @param string $iNSTANCEIDENTIFIER
     * @param \StructType\HEADER $hEADER
     * @param \StructType\Base64Binary $cONTENT
     */
    public function __construct($iNSTANCEIDENTIFIER = null, \StructType\HEADER $hEADER = null, \StructType\Base64Binary $cONTENT = null)
    {
        $this
            ->setINSTANCEIDENTIFIER($iNSTANCEIDENTIFIER)
            ->setHEADER($hEADER)
            ->setCONTENT($cONTENT);
    }
    /**
     * Get INSTANCEIDENTIFIER value
     * @return string|null
     */
    public function getINSTANCEIDENTIFIER()
    {
        return $this->INSTANCEIDENTIFIER;
    }
    /**
     * Set INSTANCEIDENTIFIER value
     * @param string $iNSTANCEIDENTIFIER
     * @return \StructType\ENVELOPE
     */
    public function setINSTANCEIDENTIFIER($iNSTANCEIDENTIFIER = null)
    {
        // validation for constraint: string
        if (!is_null($iNSTANCEIDENTIFIER) && !is_string($iNSTANCEIDENTIFIER)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iNSTANCEIDENTIFIER)), __LINE__);
        }
        $this->INSTANCEIDENTIFIER = $iNSTANCEIDENTIFIER;
        return $this;
    }
    /**
     * Get HEADER value
     * @return \StructType\HEADER|null
     */
    public function getHEADER()
    {
        return $this->HEADER;
    }
    /**
     * Set HEADER value
     * @param \StructType\HEADER $hEADER
     * @return \StructType\ENVELOPE
     */
    public function setHEADER(\StructType\HEADER $hEADER = null)
    {
        $this->HEADER = $hEADER;
        return $this;
    }
    /**
     * Get CONTENT value
     * @return \StructType\Base64Binary|null
     */
    public function getCONTENT()
    {
        return $this->CONTENT;
    }
    /**
     * Set CONTENT value
     * @param \StructType\Base64Binary $cONTENT
     * @return \StructType\ENVELOPE
     */
    public function setCONTENT(\StructType\Base64Binary $cONTENT = null)
    {
        $this->CONTENT = $cONTENT;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ENVELOPE
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
