<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetInvoiceStatusAllRequest StructType
 * @subpackage Structs
 */
class GetInvoiceStatusAllRequest extends REQUEST
{
    /**
     * The UUID
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $UUID;
    /**
     * Constructor method for GetInvoiceStatusAllRequest
     * @uses GetInvoiceStatusAllRequest::setUUID()
     * @param string[] $uUID
     */
    public function __construct(array $uUID = array())
    {
        $this
            ->setUUID($uUID);
    }
    /**
     * Get UUID value
     * @return string[]|null
     */
    public function getUUID()
    {
        return $this->UUID;
    }
    /**
     * Set UUID value
     * @throws \InvalidArgumentException
     * @param string[] $uUID
     * @return \StructType\GetInvoiceStatusAllRequest
     */
    public function setUUID(array $uUID = array())
    {
        foreach ($uUID as $getInvoiceStatusAllRequestUUIDItem) {
            // validation for constraint: itemType
            if (!is_string($getInvoiceStatusAllRequestUUIDItem)) {
                throw new \InvalidArgumentException(sprintf('The UUID property can only contain items of token, "%s" given', is_object($getInvoiceStatusAllRequestUUIDItem) ? get_class($getInvoiceStatusAllRequestUUIDItem) : gettype($getInvoiceStatusAllRequestUUIDItem)), __LINE__);
            }
        }
        $this->UUID = $uUID;
        return $this;
    }
    /**
     * Add item to UUID value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\GetInvoiceStatusAllRequest
     */
    public function addToUUID($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The UUID property can only contain items of token, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->UUID[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetInvoiceStatusAllRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
