<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetSessionInfoResponse StructType
 * Meta informations extracted from the WSDL
 * - type: tns:GetSessionInfoResponse
 * @subpackage Structs
 */
class GetSessionInfoResponse extends AbstractStructBase
{
    /**
     * The ISVALID
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $ISVALID;
    /**
     * The EXISTFROM
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $EXISTFROM;
    /**
     * The REQUEST_RETURN
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\REQUEST_RETURNType
     */
    public $REQUEST_RETURN;
    /**
     * Constructor method for GetSessionInfoResponse
     * @uses GetSessionInfoResponse::setISVALID()
     * @uses GetSessionInfoResponse::setEXISTFROM()
     * @uses GetSessionInfoResponse::setREQUEST_RETURN()
     * @param bool $iSVALID
     * @param string $eXISTFROM
     * @param \StructType\REQUEST_RETURNType $rEQUEST_RETURN
     */
    public function __construct($iSVALID = null, $eXISTFROM = null, \StructType\REQUEST_RETURNType $rEQUEST_RETURN = null)
    {
        $this
            ->setISVALID($iSVALID)
            ->setEXISTFROM($eXISTFROM)
            ->setREQUEST_RETURN($rEQUEST_RETURN);
    }
    /**
     * Get ISVALID value
     * @return bool
     */
    public function getISVALID()
    {
        return $this->ISVALID;
    }
    /**
     * Set ISVALID value
     * @param bool $iSVALID
     * @return \StructType\GetSessionInfoResponse
     */
    public function setISVALID($iSVALID = null)
    {
        $this->ISVALID = $iSVALID;
        return $this;
    }
    /**
     * Get EXISTFROM value
     * @return string
     */
    public function getEXISTFROM()
    {
        return $this->EXISTFROM;
    }
    /**
     * Set EXISTFROM value
     * @param string $eXISTFROM
     * @return \StructType\GetSessionInfoResponse
     */
    public function setEXISTFROM($eXISTFROM = null)
    {
        // validation for constraint: string
        if (!is_null($eXISTFROM) && !is_string($eXISTFROM)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($eXISTFROM)), __LINE__);
        }
        $this->EXISTFROM = $eXISTFROM;
        return $this;
    }
    /**
     * Get REQUEST_RETURN value
     * @return \StructType\REQUEST_RETURNType|null
     */
    public function getREQUEST_RETURN()
    {
        return $this->REQUEST_RETURN;
    }
    /**
     * Set REQUEST_RETURN value
     * @param \StructType\REQUEST_RETURNType $rEQUEST_RETURN
     * @return \StructType\GetSessionInfoResponse
     */
    public function setREQUEST_RETURN(\StructType\REQUEST_RETURNType $rEQUEST_RETURN = null)
    {
        $this->REQUEST_RETURN = $rEQUEST_RETURN;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetSessionInfoResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
