<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetUserListResponseX StructType
 * @subpackage Structs
 */
class GetUserListResponseX extends AbstractStructBase
{
    /**
     * The Items
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\GIBUSER[]
     */
    public $Items;
    /**
     * Constructor method for GetUserListResponseX
     * @uses GetUserListResponseX::setItems()
     * @param \StructType\GIBUSER[] $items
     */
    public function __construct(array $items = array())
    {
        $this
            ->setItems($items);
    }
    /**
     * Get Items value
     * @return \StructType\GIBUSER[]|null
     */
    public function getItems()
    {
        return $this->Items;
    }
    /**
     * Set Items value
     * @throws \InvalidArgumentException
     * @param \StructType\GIBUSER[] $items
     * @return \StructType\GetUserListResponseX
     */
    public function setItems(array $items = array())
    {
        foreach ($items as $getUserListResponseXItemsItem) {
            // validation for constraint: itemType
            if (!$getUserListResponseXItemsItem instanceof \StructType\GIBUSER) {
                throw new \InvalidArgumentException(sprintf('The Items property can only contain items of \StructType\GIBUSER, "%s" given', is_object($getUserListResponseXItemsItem) ? get_class($getUserListResponseXItemsItem) : gettype($getUserListResponseXItemsItem)), __LINE__);
            }
        }
        $this->Items = $items;
        return $this;
    }
    /**
     * Add item to Items value
     * @throws \InvalidArgumentException
     * @param \StructType\GIBUSER $item
     * @return \StructType\GetUserListResponseX
     */
    public function addToItems(\StructType\GIBUSER $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GIBUSER) {
            throw new \InvalidArgumentException(sprintf('The Items property can only contain items of \StructType\GIBUSER, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Items[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetUserListResponseX
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
