<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for INTERNETSALESDETAILS StructType
 * @subpackage Structs
 */
class INTERNETSALESDETAILS extends AbstractStructBase
{
    /**
     * The webAdresi
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $webAdresi;
    /**
     * The odemeSekli
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $odemeSekli;
    /**
     * The odemeAracisiAdi
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $odemeAracisiAdi;
    /**
     * The odemeTarihi
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $odemeTarihi;
    /**
     * The gonderiBilgileri
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\GonderiBilgileri
     */
    public $gonderiBilgileri;
    /**
     * Constructor method for INTERNETSALESDETAILS
     * @uses INTERNETSALESDETAILS::setWebAdresi()
     * @uses INTERNETSALESDETAILS::setOdemeSekli()
     * @uses INTERNETSALESDETAILS::setOdemeAracisiAdi()
     * @uses INTERNETSALESDETAILS::setOdemeTarihi()
     * @uses INTERNETSALESDETAILS::setGonderiBilgileri()
     * @param string $webAdresi
     * @param string $odemeSekli
     * @param string $odemeAracisiAdi
     * @param string $odemeTarihi
     * @param \StructType\GonderiBilgileri $gonderiBilgileri
     */
    public function __construct($webAdresi = null, $odemeSekli = null, $odemeAracisiAdi = null, $odemeTarihi = null, \StructType\GonderiBilgileri $gonderiBilgileri = null)
    {
        $this
            ->setWebAdresi($webAdresi)
            ->setOdemeSekli($odemeSekli)
            ->setOdemeAracisiAdi($odemeAracisiAdi)
            ->setOdemeTarihi($odemeTarihi)
            ->setGonderiBilgileri($gonderiBilgileri);
    }
    /**
     * Get webAdresi value
     * @return string|null
     */
    public function getWebAdresi()
    {
        return $this->webAdresi;
    }
    /**
     * Set webAdresi value
     * @param string $webAdresi
     * @return \StructType\INTERNETSALESDETAILS
     */
    public function setWebAdresi($webAdresi = null)
    {
        // validation for constraint: string
        if (!is_null($webAdresi) && !is_string($webAdresi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($webAdresi)), __LINE__);
        }
        $this->webAdresi = $webAdresi;
        return $this;
    }
    /**
     * Get odemeSekli value
     * @return string|null
     */
    public function getOdemeSekli()
    {
        return $this->odemeSekli;
    }
    /**
     * Set odemeSekli value
     * @param string $odemeSekli
     * @return \StructType\INTERNETSALESDETAILS
     */
    public function setOdemeSekli($odemeSekli = null)
    {
        // validation for constraint: string
        if (!is_null($odemeSekli) && !is_string($odemeSekli)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($odemeSekli)), __LINE__);
        }
        $this->odemeSekli = $odemeSekli;
        return $this;
    }
    /**
     * Get odemeAracisiAdi value
     * @return string|null
     */
    public function getOdemeAracisiAdi()
    {
        return $this->odemeAracisiAdi;
    }
    /**
     * Set odemeAracisiAdi value
     * @param string $odemeAracisiAdi
     * @return \StructType\INTERNETSALESDETAILS
     */
    public function setOdemeAracisiAdi($odemeAracisiAdi = null)
    {
        // validation for constraint: string
        if (!is_null($odemeAracisiAdi) && !is_string($odemeAracisiAdi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($odemeAracisiAdi)), __LINE__);
        }
        $this->odemeAracisiAdi = $odemeAracisiAdi;
        return $this;
    }
    /**
     * Get odemeTarihi value
     * @return string|null
     */
    public function getOdemeTarihi()
    {
        return $this->odemeTarihi;
    }
    /**
     * Set odemeTarihi value
     * @param string $odemeTarihi
     * @return \StructType\INTERNETSALESDETAILS
     */
    public function setOdemeTarihi($odemeTarihi = null)
    {
        // validation for constraint: string
        if (!is_null($odemeTarihi) && !is_string($odemeTarihi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($odemeTarihi)), __LINE__);
        }
        $this->odemeTarihi = $odemeTarihi;
        return $this;
    }
    /**
     * Get gonderiBilgileri value
     * @return \StructType\GonderiBilgileri|null
     */
    public function getGonderiBilgileri()
    {
        return $this->gonderiBilgileri;
    }
    /**
     * Set gonderiBilgileri value
     * @param \StructType\GonderiBilgileri $gonderiBilgileri
     * @return \StructType\INTERNETSALESDETAILS
     */
    public function setGonderiBilgileri(\StructType\GonderiBilgileri $gonderiBilgileri = null)
    {
        $this->gonderiBilgileri = $gonderiBilgileri;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\INTERNETSALESDETAILS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
