<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for INVOICE_STATUS StructType
 * @subpackage Structs
 */
class INVOICE_STATUS extends INVOICE
{
    /**
     * The STATUS
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $STATUS;
    /**
     * The STATUS_DESCRIPTION
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $STATUS_DESCRIPTION;
    /**
     * The GIB_STATUS_CODE
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $GIB_STATUS_CODE;
    /**
     * The GIB_STATUS_DESCRIPTION
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $GIB_STATUS_DESCRIPTION;
    /**
     * The RESPONSE_CODE
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RESPONSE_CODE;
    /**
     * The RESPONSE_DESCRIPTION
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RESPONSE_DESCRIPTION;
    /**
     * The CDATE
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CDATE;
    /**
     * The ENVELOPE_IDENTIFIER
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ENVELOPE_IDENTIFIER;
    /**
     * Constructor method for INVOICE_STATUS
     * @uses INVOICE_STATUS::setSTATUS()
     * @uses INVOICE_STATUS::setSTATUS_DESCRIPTION()
     * @uses INVOICE_STATUS::setGIB_STATUS_CODE()
     * @uses INVOICE_STATUS::setGIB_STATUS_DESCRIPTION()
     * @uses INVOICE_STATUS::setRESPONSE_CODE()
     * @uses INVOICE_STATUS::setRESPONSE_DESCRIPTION()
     * @uses INVOICE_STATUS::setCDATE()
     * @uses INVOICE_STATUS::setENVELOPE_IDENTIFIER()
     * @param string $sTATUS
     * @param string $sTATUS_DESCRIPTION
     * @param int $gIB_STATUS_CODE
     * @param string $gIB_STATUS_DESCRIPTION
     * @param string $rESPONSE_CODE
     * @param string $rESPONSE_DESCRIPTION
     * @param string $cDATE
     * @param string $eNVELOPE_IDENTIFIER
     */
    public function __construct($sTATUS = null, $sTATUS_DESCRIPTION = null, $gIB_STATUS_CODE = null, $gIB_STATUS_DESCRIPTION = null, $rESPONSE_CODE = null, $rESPONSE_DESCRIPTION = null, $cDATE = null, $eNVELOPE_IDENTIFIER = null)
    {
        $this
            ->setSTATUS($sTATUS)
            ->setSTATUS_DESCRIPTION($sTATUS_DESCRIPTION)
            ->setGIB_STATUS_CODE($gIB_STATUS_CODE)
            ->setGIB_STATUS_DESCRIPTION($gIB_STATUS_DESCRIPTION)
            ->setRESPONSE_CODE($rESPONSE_CODE)
            ->setRESPONSE_DESCRIPTION($rESPONSE_DESCRIPTION)
            ->setCDATE($cDATE)
            ->setENVELOPE_IDENTIFIER($eNVELOPE_IDENTIFIER);
    }
    /**
     * Get STATUS value
     * @return string|null
     */
    public function getSTATUS()
    {
        return $this->STATUS;
    }
    /**
     * Set STATUS value
     * @param string $sTATUS
     * @return \StructType\INVOICE_STATUS
     */
    public function setSTATUS($sTATUS = null)
    {
        // validation for constraint: string
        if (!is_null($sTATUS) && !is_string($sTATUS)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sTATUS)), __LINE__);
        }
        $this->STATUS = $sTATUS;
        return $this;
    }
    /**
     * Get STATUS_DESCRIPTION value
     * @return string|null
     */
    public function getSTATUS_DESCRIPTION()
    {
        return $this->STATUS_DESCRIPTION;
    }
    /**
     * Set STATUS_DESCRIPTION value
     * @param string $sTATUS_DESCRIPTION
     * @return \StructType\INVOICE_STATUS
     */
    public function setSTATUS_DESCRIPTION($sTATUS_DESCRIPTION = null)
    {
        // validation for constraint: string
        if (!is_null($sTATUS_DESCRIPTION) && !is_string($sTATUS_DESCRIPTION)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sTATUS_DESCRIPTION)), __LINE__);
        }
        $this->STATUS_DESCRIPTION = $sTATUS_DESCRIPTION;
        return $this;
    }
    /**
     * Get GIB_STATUS_CODE value
     * @return int|null
     */
    public function getGIB_STATUS_CODE()
    {
        return $this->GIB_STATUS_CODE;
    }
    /**
     * Set GIB_STATUS_CODE value
     * @param int $gIB_STATUS_CODE
     * @return \StructType\INVOICE_STATUS
     */
    public function setGIB_STATUS_CODE($gIB_STATUS_CODE = null)
    {
        // validation for constraint: int
        if (!is_null($gIB_STATUS_CODE) && !is_numeric($gIB_STATUS_CODE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($gIB_STATUS_CODE)), __LINE__);
        }
        $this->GIB_STATUS_CODE = $gIB_STATUS_CODE;
        return $this;
    }
    /**
     * Get GIB_STATUS_DESCRIPTION value
     * @return string|null
     */
    public function getGIB_STATUS_DESCRIPTION()
    {
        return $this->GIB_STATUS_DESCRIPTION;
    }
    /**
     * Set GIB_STATUS_DESCRIPTION value
     * @param string $gIB_STATUS_DESCRIPTION
     * @return \StructType\INVOICE_STATUS
     */
    public function setGIB_STATUS_DESCRIPTION($gIB_STATUS_DESCRIPTION = null)
    {
        // validation for constraint: string
        if (!is_null($gIB_STATUS_DESCRIPTION) && !is_string($gIB_STATUS_DESCRIPTION)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($gIB_STATUS_DESCRIPTION)), __LINE__);
        }
        $this->GIB_STATUS_DESCRIPTION = $gIB_STATUS_DESCRIPTION;
        return $this;
    }
    /**
     * Get RESPONSE_CODE value
     * @return string|null
     */
    public function getRESPONSE_CODE()
    {
        return $this->RESPONSE_CODE;
    }
    /**
     * Set RESPONSE_CODE value
     * @param string $rESPONSE_CODE
     * @return \StructType\INVOICE_STATUS
     */
    public function setRESPONSE_CODE($rESPONSE_CODE = null)
    {
        // validation for constraint: string
        if (!is_null($rESPONSE_CODE) && !is_string($rESPONSE_CODE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rESPONSE_CODE)), __LINE__);
        }
        $this->RESPONSE_CODE = $rESPONSE_CODE;
        return $this;
    }
    /**
     * Get RESPONSE_DESCRIPTION value
     * @return string|null
     */
    public function getRESPONSE_DESCRIPTION()
    {
        return $this->RESPONSE_DESCRIPTION;
    }
    /**
     * Set RESPONSE_DESCRIPTION value
     * @param string $rESPONSE_DESCRIPTION
     * @return \StructType\INVOICE_STATUS
     */
    public function setRESPONSE_DESCRIPTION($rESPONSE_DESCRIPTION = null)
    {
        // validation for constraint: string
        if (!is_null($rESPONSE_DESCRIPTION) && !is_string($rESPONSE_DESCRIPTION)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rESPONSE_DESCRIPTION)), __LINE__);
        }
        $this->RESPONSE_DESCRIPTION = $rESPONSE_DESCRIPTION;
        return $this;
    }
    /**
     * Get CDATE value
     * @return string|null
     */
    public function getCDATE()
    {
        return $this->CDATE;
    }
    /**
     * Set CDATE value
     * @param string $cDATE
     * @return \StructType\INVOICE_STATUS
     */
    public function setCDATE($cDATE = null)
    {
        // validation for constraint: string
        if (!is_null($cDATE) && !is_string($cDATE)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cDATE)), __LINE__);
        }
        $this->CDATE = $cDATE;
        return $this;
    }
    /**
     * Get ENVELOPE_IDENTIFIER value
     * @return string|null
     */
    public function getENVELOPE_IDENTIFIER()
    {
        return $this->ENVELOPE_IDENTIFIER;
    }
    /**
     * Set ENVELOPE_IDENTIFIER value
     * @param string $eNVELOPE_IDENTIFIER
     * @return \StructType\INVOICE_STATUS
     */
    public function setENVELOPE_IDENTIFIER($eNVELOPE_IDENTIFIER = null)
    {
        // validation for constraint: string
        if (!is_null($eNVELOPE_IDENTIFIER) && !is_string($eNVELOPE_IDENTIFIER)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($eNVELOPE_IDENTIFIER)), __LINE__);
        }
        $this->ENVELOPE_IDENTIFIER = $eNVELOPE_IDENTIFIER;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\INVOICE_STATUS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
