<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SENDER StructType
 * @subpackage Structs
 */
class SENDER extends AbstractStructBase
{
    /**
     * The vkn
     * @var string
     */
    public $vkn;
    /**
     * The alias
     * @var string
     */
    public $alias;
    /**
     * Constructor method for SENDER
     * @uses SENDER::setVkn()
     * @uses SENDER::setAlias()
     * @param string $vkn
     * @param string $alias
     */
    public function __construct($vkn = null, $alias = null)
    {
        $this
            ->setVkn($vkn)
            ->setAlias($alias);
    }
    /**
     * Get vkn value
     * @return string|null
     */
    public function getVkn()
    {
        return $this->vkn;
    }
    /**
     * Set vkn value
     * @param string $vkn
     * @return \StructType\SENDER
     */
    public function setVkn($vkn = null)
    {
        // validation for constraint: string
        if (!is_null($vkn) && !is_string($vkn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vkn)), __LINE__);
        }
        $this->vkn = $vkn;
        return $this;
    }
    /**
     * Get alias value
     * @return string|null
     */
    public function getAlias()
    {
        return $this->alias;
    }
    /**
     * Set alias value
     * @param string $alias
     * @return \StructType\SENDER
     */
    public function setAlias($alias = null)
    {
        // validation for constraint: string
        if (!is_null($alias) && !is_string($alias)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($alias)), __LINE__);
        }
        $this->alias = $alias;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SENDER
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
