<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendInvoiceResponseRequest StructType
 * Meta informations extracted from the WSDL
 * - type: tns:SendInvoiceResponseRequest
 * @subpackage Structs
 */
class SendInvoiceResponseRequest extends REQUEST
{
    /**
     * The APPRESPONSE
     * Meta informations extracted from the WSDL
     * - form: unqualified
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Base64Binary[]
     */
    public $APPRESPONSE;
    /**
     * Constructor method for SendInvoiceResponseRequest
     * @uses SendInvoiceResponseRequest::setAPPRESPONSE()
     * @param \StructType\Base64Binary[] $aPPRESPONSE
     */
    public function __construct(array $aPPRESPONSE = array())
    {
        $this
            ->setAPPRESPONSE($aPPRESPONSE);
    }
    /**
     * Get APPRESPONSE value
     * @return \StructType\Base64Binary[]|null
     */
    public function getAPPRESPONSE()
    {
        return $this->APPRESPONSE;
    }
    /**
     * Set APPRESPONSE value
     * @throws \InvalidArgumentException
     * @param \StructType\Base64Binary[] $aPPRESPONSE
     * @return \StructType\SendInvoiceResponseRequest
     */
    public function setAPPRESPONSE(array $aPPRESPONSE = array())
    {
        foreach ($aPPRESPONSE as $sendInvoiceResponseRequestAPPRESPONSEItem) {
            // validation for constraint: itemType
            if (!$sendInvoiceResponseRequestAPPRESPONSEItem instanceof \StructType\Base64Binary) {
                throw new \InvalidArgumentException(sprintf('The APPRESPONSE property can only contain items of \StructType\Base64Binary, "%s" given', is_object($sendInvoiceResponseRequestAPPRESPONSEItem) ? get_class($sendInvoiceResponseRequestAPPRESPONSEItem) : gettype($sendInvoiceResponseRequestAPPRESPONSEItem)), __LINE__);
            }
        }
        $this->APPRESPONSE = $aPPRESPONSE;
        return $this;
    }
    /**
     * Add item to APPRESPONSE value
     * @throws \InvalidArgumentException
     * @param \StructType\Base64Binary $item
     * @return \StructType\SendInvoiceResponseRequest
     */
    public function addToAPPRESPONSE(\StructType\Base64Binary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Base64Binary) {
            throw new \InvalidArgumentException(sprintf('The APPRESPONSE property can only contain items of \StructType\Base64Binary, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->APPRESPONSE[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SendInvoiceResponseRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
